> ## Documentation Index
> Fetch the complete documentation index at: https://conductorone-docs-mcp-bridge-private-server.mintlify.site/llms.txt
> Use this file to discover all available pages before exploring further.

# Update Grant Duration

> Update the expiration time of an existing grant, changing when automatic revocation will occur.



## OpenAPI

````yaml https://spec.speakeasy.com/conductor-one/conductorone/my-source-with-code-samples post /api/v1/apps/{app_id}/entitlements/{app_entitlement_id}/users/{app_user_id}/update-grant-duration
openapi: 3.1.0
info:
  description: The C1 API is a HTTP API for managing C1 resources.
  title: C1 API
  version: 0.1.0-alpha
servers:
  - description: The C1 API server for the current tenant.
    url: https://{tenantDomain}.conductor.one
    variables:
      tenantDomain:
        default: example
        description: The domain of the tenant to use for this request.
security:
  - bearerAuth: []
    oauth: []
paths:
  /api/v1/apps/{app_id}/entitlements/{app_entitlement_id}/users/{app_user_id}/update-grant-duration:
    post:
      tags:
        - App Entitlement User Binding
      summary: Update Grant Duration
      description: >-
        Update the expiration time of an existing grant, changing when automatic
        revocation will occur.
      operationId: c1.api.app.v1.AppEntitlementUserBindingService.UpdateGrantDuration
      parameters:
        - in: path
          name: app_id
          required: true
          schema:
            description: The ID of the app that owns the entitlement.
            type: string
        - in: path
          name: app_entitlement_id
          required: true
          schema:
            description: The ID of the entitlement whose grant duration is being updated.
            type: string
        - in: path
          name: app_user_id
          required: true
          schema:
            description: The ID of the app user whose grant is being updated.
            type: string
      requestBody:
        content:
          application/json:
            schema:
              $ref: >-
                #/components/schemas/c1.api.app.v1.UpdateGrantDurationRequestInput
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/c1.api.app.v1.UpdateGrantDurationResponse'
          description: The response message for updating the duration of a grant.
      x-codeSamples:
        - lang: go
          label: UpdateGrantDuration
          source: "package main\n\nimport(\n\t\"context\"\n\t\"github.com/conductorone/conductorone-sdk-go/pkg/models/shared\"\n\tconductoronesdkgo \"github.com/conductorone/conductorone-sdk-go\"\n\t\"github.com/conductorone/conductorone-sdk-go/pkg/models/operations\"\n\t\"log\"\n)\n\nfunc main() {\n    ctx := context.Background()\n\n    s := conductoronesdkgo.New(\n        conductoronesdkgo.WithSecurity(shared.Security{\n            BearerAuth: \"<YOUR_BEARER_TOKEN_HERE>\",\n            Oauth: \"<YOUR_OAUTH_HERE>\",\n        }),\n    )\n\n    res, err := s.AppEntitlementUserBinding.UpdateGrantDuration(ctx, operations.C1APIAppV1AppEntitlementUserBindingServiceUpdateGrantDurationRequest{\n        AppEntitlementID: \"<id>\",\n        AppID: \"<id>\",\n        AppUserID: \"<id>\",\n    })\n    if err != nil {\n        log.Fatal(err)\n    }\n    if res.UpdateGrantDurationResponse != nil {\n        // handle response\n    }\n}"
        - lang: typescript
          label: Typescript (SDK)
          source: >-
            import { ConductoroneSDKTypescript } from
            "conductorone-sdk-typescript";


            const conductoroneSDKTypescript = new ConductoroneSDKTypescript({
              security: {
                bearerAuth: "<YOUR_BEARER_TOKEN_HERE>",
                oauth: "<YOUR_OAUTH_HERE>",
              },
            });


            async function run() {
              const result = await conductoroneSDKTypescript.appEntitlementUserBinding.updateGrantDuration({
                appId: "<id>",
                appEntitlementId: "<id>",
                appUserId: "<id>",
              });

              console.log(result);
            }


            run();
components:
  schemas:
    c1.api.app.v1.UpdateGrantDurationRequestInput:
      description: The request message for updating the duration of an existing grant.
      properties:
        newDeprovisionAt:
          format: date-time
          type:
            - string
            - 'null'
      title: Update Grant Duration Request
      type: object
      x-speakeasy-name-override: UpdateGrantDurationRequest
    c1.api.app.v1.UpdateGrantDurationResponse:
      description: The response message for updating the duration of a grant.
      properties:
        binding:
          oneOf:
            - $ref: '#/components/schemas/c1.api.app.v1.AppEntitlementUserBinding'
            - type: 'null'
      title: Update Grant Duration Response
      type: object
      x-speakeasy-name-override: UpdateGrantDurationResponse
    c1.api.app.v1.AppEntitlementUserBinding:
      description: >-
        The AppEntitlementUserBinding represents the relationship that gives an
        app user access to an app entitlement
      properties:
        appEntitlementId:
          description: The ID of the app entitlement that the app user has access to
          type:
            - string
            - 'null'
        appId:
          description: The ID of the app associated with the app entitlement
          type:
            - string
            - 'null'
        appUserId:
          description: The ID of the app user that has access to the app entitlement
          type:
            - string
            - 'null'
        createdAt:
          format: date-time
          readOnly: true
          type:
            - string
            - 'null'
        deletedAt:
          format: date-time
          readOnly: true
          type:
            - string
            - 'null'
        deprovisionAt:
          format: date-time
          readOnly: true
          type:
            - string
            - 'null'
        grantSources:
          description: The grantSources field.
          items:
            $ref: '#/components/schemas/c1.api.app.v1.AppEntitlementRef'
          type:
            - array
            - 'null'
      title: App Entitlement User Binding
      type: object
      x-speakeasy-name-override: AppEntitlementUserBinding
    c1.api.app.v1.AppEntitlementRef:
      description: The AppEntitlementRef message.
      properties:
        appId:
          description: The appId field.
          type:
            - string
            - 'null'
        id:
          description: The id field.
          type:
            - string
            - 'null'
      title: App Entitlement Ref
      type: object
      x-speakeasy-name-override: AppEntitlementRef
  securitySchemes:
    bearerAuth:
      scheme: bearer
      type: http
    oauth:
      description: >-
        This API uses OAuth2 with the Client Credential flow.

        Client Credentials must be sent in the BODY, not the headers.

        For an example of how to implement this, refer to the
        [c1TokenSource.Token()](https://github.com/ConductorOne/conductorone-sdk-go/blob/3375fe7c0126d17e7ec4e711693dee7b791023aa/token_source.go#L101-L187)
        function.
      flows:
        clientCredentials:
          scopes: {}
          tokenUrl: /auth/v1/token
      type: oauth2

````